Name: wwwoffle
Version: 2.8e
Release: alt1

%define ROOT %_cachedir/%name
%define uid wwwoffle

Summary: WWW Offline Explorer - Caching Web Proxy Server
License: GPL
Group: System/Servers
Url: http://www.gedanken.demon.co.uk/wwwoffle/

# ftp://ftp.demon.co.uk/pub/unix/httpd/
Source: %name-%version.tgz
Source1: %name.init
Source2: %name.cron.weekly

# 1) run as %uid:%uid
# 2) restrict filesystem permissions
# 3) listen IPv4/127.0.0.1 only
Patch1: %name-2.8-alt-config.patch

Patch2: %name-2.8b-alt-gnu-source.patch

# http://www.phys.uu.nl/~rombouts/wwwoffle.html
#atch3: http://www.phys.uu.nl/~rombouts/%name-%version-par.diff.gz

# Automatically added by buildreq on Tue Nov 11 2003
BuildRequires: flex zlib-devel

%description 
A proxy HTTP/FTP server for computers with dial-up internet access.
- Caching of pages viewed while connected for review later.
- Browsing of cached pages while not connected, with the ability
  to follow links and mark other pages for download.
- Downloading of specified pages non-interactively.
- Multiple indices of pages stored in cache for easy selection.
- Interactive or command line option to select pages for fetching
  individually or recursively.
- All options controlled using a simple configuration file with a
  web page to edit it.

%prep
%setup -q
%patch1 -p1
%patch2 -p1

%build
%configure --with-zlib --with-ipv6 --with-spooldir=%ROOT
%make_build CFLAGS='%optflags -D_GNU_SOURCE -Wall'

%install
%make_install install \
	DESTDIR=%buildroot \
	SPOOLDIR=%buildroot%ROOT \
	CONFDIR=%buildroot%_sysconfdir \
	MANDIR=%buildroot%_mandir \
	docdir=%buildroot%_docdir/%name-%version
%__cp -a contrib %buildroot%_docdir/%name-%version
%__cp -a ChangeLog* %buildroot%_docdir/%name-%version
%__mv -f %buildroot%ROOT/search %buildroot%_docdir/%name-%version
%__mkdir_p %buildroot%_initdir
%__mkdir_p %buildroot%_sysconfdir/cron.weekly
%__install -p -m755 %SOURCE1 %buildroot%_initdir/%name
%__install -p -m755 %SOURCE2 %buildroot%_sysconfdir/cron.weekly/%name 
%__chmod -R go-wx,a+rX %buildroot%_docdir

%__mkdir_p %buildroot%_sysconfdir/ppp/ip-{up,down}.d
%__cat <<EOF >%buildroot%_sysconfdir/ppp/ip-up.d/%name
#!/bin/sh
%_bindir/%name -online
%_bindir/%name -fetch &
EOF
%__cat <<EOF >%buildroot%_sysconfdir/ppp/ip-down.d/%name
#!/bin/sh
%_bindir/%name -offline
EOF

%pre
/usr/sbin/groupadd -r -f %uid >/dev/null 2>&1 ||:
/usr/sbin/useradd -r -g %uid -d /dev/null -s /dev/null -n %uid >/dev/null 2>&1 ||:

%post
%post_service %name

%preun
%preun_service %name

%files
# daemon will create/move more directories under %ROOT
%attr(3771,root,%uid) %dir %ROOT
%attr(0755,root,%uid) %dir %ROOT/html
%dir %ROOT/html/de
%dir %ROOT/html/en
%dir %ROOT/html/es
%dir %ROOT/html/fr
%dir %ROOT/html/it
%dir %ROOT/html/nl
%dir %ROOT/html/pl
%dir %ROOT/html/ru
%dir %ROOT/html/de/messages
%dir %ROOT/html/en/messages
%dir %ROOT/html/es/messages
%dir %ROOT/html/fr/messages
%dir %ROOT/html/it/messages
%dir %ROOT/html/nl/messages
%dir %ROOT/html/pl/messages
%dir %ROOT/html/ru/messages
# default -> en
%ROOT/html/default
%ROOT/html/README
%ROOT/html/??/*.*
%ROOT/html/??/search
%ROOT/html/??/local
%ROOT/html/??/messages/README*
%config(noreplace) %ROOT/html/??/messages/*.html
%attr(3775,root,%uid) %dir %ROOT/local
%attr(0750,%uid,%uid) %dir %ROOT/http
%attr(0750,%uid,%uid) %dir %ROOT/lastout
%attr(0750,%uid,%uid) %dir %ROOT/lasttime
%attr(0750,%uid,%uid) %dir %ROOT/monitor
%attr(0750,%uid,%uid) %dir %ROOT/outgoing
%attr(0750,%uid,%uid) %dir %ROOT/prevtime1
# config file should be readable after setuid/setgid (reload)
# 	but there could be passwords in it etc., so it should not be world readable.
# config file should be writable after setuid/setgid (web configurator)
#	Note: this has been disabled to prevent %uid -> root privilege escalation.
%attr(0640,root,%uid) %config(noreplace) %_sysconfdir/wwwoffle.conf
%attr(0755,root,root) %config(noreplace) %_sysconfdir/cron.weekly/%name
%attr(0755,root,root) %config %_initdir/%name
%_bindir/%{name}*
%_sbindir/%{name}*
%attr(0755,root,root) %_sysconfdir/ppp/ip-up.d/%name
%attr(0755,root,root) %_sysconfdir/ppp/ip-down.d/%name
%_mandir/man?/%{name}*
%_docdir/%name-%version

%changelog
* Thu Mar 23 2006 Eugene V. Horohorin <genix@altlinux.ru> 2.8e-alt1
- 2.8e
- repplace -Werror with -Wall

* Thu Feb 19 2004 Alexey Tourbin <at@altlinux.ru> 2.8b-alt1
- 2.8b

* Mon Dec 15 2003 Alexey Tourbin <at@altlinux.ru> 2.8a-alt1
- 2.8a

* Tue Nov 11 2003 Alexey Tourbin <at@altlinux.ru> 2.8-alt1
- 2.8
- new init script according to new rc scheme
- listen 127.0.0.1 only by default (#2915)
- ppp scripts (automatic online/offline switch)
- restricted config file permissions (0660,root,%uid -> 0640,root,%uid),
  web configurator will not work
- built with -D_GNU_SOURCE -Werror

* Mon Jan 13 2003 Alexey Tourbin <at@altlinux.ru> 2.7h-alt1
- 2.7h (bugfix release)

* Mon Dec 09 2002 Alexey Tourbin <at@altlinux.ru> 2.7g-alt1
- 2.7g (configuration syntax changes; see CHANGES.CONF)

* Tue Oct 01 2002 Alexey Tourbin <at@altlinux.ru> 2.7f-alt1
- 2.7f (bugfix release)
- %ROOT/html/*/messages/*.html marked as configuration files
- %%SOURCE0 repacked with bzip2

* Thu Sep 05 2002 Alexey Tourbin <at@turbinal.org> 2.7e-alt1
- 2.7e
- serach scripts moved from %ROOT to documentation
- Sisyphus candidate

* Fri Aug 09 2002 Alexey Tourbin <at@turbinal.org> 2.7d-alt1
- 2.7d

* Sun Jul 21 2002 Alexey Tourbin <at@turbinal.org> 2.7c-alt1
- 2.7c
- poor htdig integration dropped
- runs as %uid:%uid
- init script rewritten
- ALT Linux adaptations

* Tue Aug 28 2001  Lenny Cartier <lenny@mandrakesoft.com> 2.6d-1mdk
- 2.6d

* Thu Jun 14 2001 Lenny Cartier <lenny@mandrakesoft.com> 2.6c-3mdk
- updated by Laurent Grawet <laurent.grawet@ibelgique.com> :
	- Updated to 2.6c.

* Tue Apr 24 2001 Giuseppe Ghib <ghibo@mandrakesoft.com> 2.6a-2mdk
- fixed changed path for htdig scripts.

* Wed Feb 14 2001 Lenny Cartier <lenny@mandrakesoft.com> 2.6a-1mdk
- updated to 2.6a.

* Sun Sep 24 2000 Giuseppe Ghib <ghibo@mandrakesoft.com> 2.5e-5mdk
- more macros.

* Sat Sep 23 2000 Giuseppe Ghib <ghibo@mandrakesoft.com> 2.5e-4mdk
- noreplace for %%config.
- fixed path for files into /var/spool/wwwoffle.
- use of perl instead of sed for path fixing.
- added CFLAGS.
- pure in cron-weekly.
- added cron for htdig.
- added contrib to %%doc.

* Sat Aug 26 2000 Ronan-Yann Lorin <ryl@linuxmandrake.com> 2.5e-3mdk
- cron task added

* Tue Aug 01 2000 Lenny Cartier <lenny@mandrakesoft.com> 2.5e-2mdk
- bm
- macros

* Thu Jul 27 2000 Ronan-Yann Lorin <ryl@free.fr> 2.5e-1mdk
- fix config file
- updated to 2.5e

* Thu May 04 2000 Lenny Cartier <lenny@mandrakesoft.com> 2.4-2mdk
- fix group

* Fri Jul 16 1999 Pablo Saratxaga <pablo@mandrakesoft.com>
- uploaded to 2.4
- * Mon Jul 12 1999 Pablo Saratxaga <pablo@mandrakesoft.com>
- adapted to mandrake the rpm package of
  Gianpaolo Macario <gianpi@geocities.com>
